Index: java/main/src/main/java/com/framsticks/experiment/Simulator.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/Simulator.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/experiment/Simulator.java	(revision 102)
@@ -1,35 +1,80 @@
 package com.framsticks.experiment;
 
-import com.framsticks.params.ParamFlags;
+import com.framsticks.communication.File;
+import com.framsticks.communication.queries.NeedFile;
+import com.framsticks.communication.queries.NeedFileAcceptor;
+import com.framsticks.core.Path;
+import com.framsticks.core.Tree;
+import com.framsticks.core.ValueChange;
+import com.framsticks.params.EventListener;
+import com.framsticks.params.FramsClass;
 import com.framsticks.params.UniqueObject;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.remote.RemoteTree;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableParent;
 import com.framsticks.util.dispatching.JoinableState;
+import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
+import com.framsticks.util.lang.Holder;
+import java.util.concurrent.atomic.AtomicInteger;
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+import static com.framsticks.core.TreeOperations.*;
 
 @FramsClassAnnotation
-public class Simulator extends AbstractJoinable implements JoinableParent, UniqueObject {
+public final class Simulator extends AbstractJoinable implements Dispatcher<Simulator>, JoinableParent, UniqueObject, ExceptionResultHandler {
+
+	private static final Logger log = LogManager.getLogger(Simulator.class);
+
 	protected String uid;
 
-	protected final RemoteTree remoteTree = new RemoteTree();
+	protected final RemoteTree remoteTree;
+	protected final Path simulatorPath;
+	protected final FramsClass simulatorClass;
+	protected final Experiment experiment;
+	protected final EventListener<ValueChange> runningListener;
 
 	/**
 	 *
 	 */
-	public Simulator() {
+	public Simulator(Experiment experiment, RemoteTree remoteTree, Path simulatorPath) {
 		super();
-	}
-
-	@ParamAnnotation
-	public void setAddress(String address) {
-		remoteTree.setAddress(address);
-	}
-
-	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
+		this.remoteTree = remoteTree;
+		this.simulatorPath = simulatorPath.assureResolved();
+		this.experiment = experiment;
+		this.simulatorClass = getFramsClass(simulatorPath);
+
+		assert remoteTree.isActive();
+		assert experiment.isActive();
+
+		log.debug("simulator ready {}", this);
+
+		runningListener = new EventListener<ValueChange>() {
+			@Override
+			public void action(ValueChange argument) {
+				log.debug("running state of {} changed: {}", this, argument);
+			}
+		};
+
+		addListener(simulatorPath, simulatorClass.getParamEntry("running_changed", EventParam.class), runningListener, ValueChange.class, new FutureHandler<Void>(this) {
+			@Override
+			protected void result(Void result) {
+				log.debug("running listener for {} registered", this);
+			}
+		});
+	}
+
+	@ParamAnnotation
 	public String getAddress() {
 		return remoteTree.getAddress();
@@ -39,6 +84,5 @@
 	@ParamAnnotation
 	public String getName() {
-
-		return "simulator " + uid + " " + getAddress();
+		return getAddress();
 	}
 
@@ -62,8 +106,21 @@
 	}
 
+	/**
+	 * @return the simulatorPath
+	 */
+	public Path getSimulatorPath() {
+		return simulatorPath;
+	}
+
+	/**
+	 * @return the simulatorClass
+	 */
+	public FramsClass getSimulatorClass() {
+		return simulatorClass;
+	}
+
 	@Override
 	protected void joinableStart() {
 		Dispatching.use(remoteTree, this);
-
 	}
 
@@ -96,4 +153,12 @@
 	}
 
+	@ParamAnnotation(paramType = ProcedureParam.class)
+	public void abort() {
+		assert isActive();
+		log.debug("explicitly aborting {}", this);
+		experiment.removeSimulator(this);
+		interruptJoinable();
+	}
+
 	@Override
 	public void childChangedState(Joinable joinable, JoinableState state) {
@@ -101,3 +166,62 @@
 	}
 
+	@Override
+	public void handle(FramsticksException exception) {
+		experiment.handle(new FramsticksException().msg("exception caught in simulator").arg("simulator", this).cause(exception));
+	}
+
+	@Override
+	public boolean isActive() {
+		return experiment.isActive();
+	}
+
+	@SuppressWarnings({ "rawtypes", "unchecked" })
+	@Override
+	public void dispatch(RunAt<? extends Simulator> runnable) {
+		experiment.dispatch((RunAt) runnable);
+	}
+
+	protected final AtomicInteger netloadIdCounter = new AtomicInteger();
+
+	public void uploadNet(final File file, final Future<Object> future) {
+		final String netloadId = "NetLoadSaveLogic" + netloadIdCounter.getAndIncrement();
+
+		log.debug("uploading file {} to {} identified by {}", file, simulatorPath, netloadId);
+
+		final Holder<NeedFileAcceptor> acceptor = new Holder<>();
+		final Tree tree = simulatorPath.getTree();
+
+		acceptor.set(new NeedFileAcceptor() {
+
+			@Override
+			public boolean acceptNeed(NeedFile needFile) {
+				if (!needFile.getDescription().equals(netloadId)) {
+					return false;
+				}
+				log.debug("accepting netload {}", netloadId);
+				needFile.getFuture().pass(file);
+				tree.dispatch(new RunAt<Tree>(ThrowExceptionHandler.getInstance()) {
+
+					@Override
+					protected void runAt() {
+						tree.removeNeedFileAcceptor(acceptor.get());
+					}
+				});
+				return true;
+			}
+
+		});
+
+		simulatorPath.getTree().addNeedFileAcceptor(Integer.MIN_VALUE, acceptor.get());
+
+		call(simulatorPath, getFramsClass(simulatorPath).getParamEntry("netload_id", ProcedureParam.class), new Object[] { netloadId }, new FutureHandler<Object>(future) {
+
+			@Override
+			protected void result(Object result) {
+				log.debug("upload of {} done", file);
+				future.pass(result);
+			}
+		});
+
+	}
 }
Index: java/main/src/main/java/com/framsticks/experiment/SimulatorConnector.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/SimulatorConnector.java	(revision 102)
+++ java/main/src/main/java/com/framsticks/experiment/SimulatorConnector.java	(revision 102)
@@ -0,0 +1,77 @@
+package com.framsticks.experiment;
+
+import org.apache.logging.log4j.Level;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import com.framsticks.communication.Address;
+import com.framsticks.core.Path;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.remote.RemoteTree;
+import com.framsticks.util.AutoAttacher;
+import com.framsticks.util.Misc;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.lang.Casting;
+import com.framsticks.util.lang.Strings;
+
+import static com.framsticks.core.TreeOperations.*;
+
+@FramsClassAnnotation
+public class SimulatorConnector implements AutoAttacher {
+	private static final Logger log = LogManager.getLogger(SimulatorConnector.class);
+
+
+	protected Experiment experiment;
+	protected Address address;
+	protected RemoteTree remoteTree;
+
+	@SuppressWarnings({ "rawtypes", "unchecked" })
+	@Override
+	public void attachTo(Object parent) {
+		experiment = Casting.throwCast(Experiment.class, parent);
+
+		Misc.throwIfNull(address);
+		log.debug("connecting to simulator at {}", address);
+		// experiment
+		remoteTree = new RemoteTree();
+		remoteTree.setAddress(address);
+		remoteTree.setDispatcher((Dispatcher) experiment.getDispatcher());
+
+
+		experiment.getSimulatorCandidates().add(remoteTree);
+
+		Dispatching.dispatchLog(remoteTree, log, Level.DEBUG, "first task in remote tree");
+
+		tryGet(remoteTree, "/simulator", new FutureHandler<Path>(experiment) {
+
+			@Override
+			protected void result(Path result) {
+				log.debug("resolved simulator path: {}", result);
+				Misc.checkEquals(experiment.getExpdef(), bindAccess(result).get("expdef", String.class), "expdef mismatch in connected simulator", this);
+
+				Simulator simulator = new Simulator(experiment, remoteTree, result);
+				experiment.addSimulator(simulator);
+				experiment.getSimulatorCandidates().remove(remoteTree);
+			}
+		});
+	}
+
+	@ParamAnnotation
+	public void setAddress(String address) {
+		this.address = new Address(address);
+	}
+
+	@ParamAnnotation
+	public String getAddress() {
+		return Strings.toStringNullProof(address, "");
+	}
+
+	@Override
+	public String toString() {
+		return "simulator connector to: " + Strings.toStringNullProof(address, "<null>");
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/experiment/WorkPackage.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/WorkPackage.java	(revision 102)
+++ java/main/src/main/java/com/framsticks/experiment/WorkPackage.java	(revision 102)
@@ -0,0 +1,5 @@
+package com.framsticks.experiment;
+
+public interface WorkPackage {
+
+}
Index: java/main/src/main/java/com/framsticks/experiment/WorkPackageLogic.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/WorkPackageLogic.java	(revision 102)
+++ java/main/src/main/java/com/framsticks/experiment/WorkPackageLogic.java	(revision 102)
@@ -0,0 +1,57 @@
+package com.framsticks.experiment;
+
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import com.framsticks.communication.File;
+import com.framsticks.params.ListSource;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
+
+@FramsClassAnnotation
+public abstract class WorkPackageLogic<WP extends WorkPackage> extends AbstractExperimentLogic {
+
+	private static final Logger log = LogManager.getLogger(WorkPackageLogic.class);
+
+	@ParamAnnotation
+	public final NetLoadSaveLogic netLoadSaveLogic;
+
+	/**
+	 * @param experiment
+	 */
+	public WorkPackageLogic(Experiment experiment) {
+		super(experiment);
+
+		netLoadSaveLogic = new NetLoadSaveLogic(experiment) {
+
+			@Override
+			public void netload(Simulator simulator, final Future<File> net) {
+				assert experiment.isActive();
+				log.debug("providing netload file for {}", simulator);
+
+				generateNextPackage(new FutureHandler<WP> (net) {
+
+					@Override
+					protected void result(WP result) {
+						log.debug("sending package: {}", result);
+						File file = new File("test-file", ListSource.createFrom("# a test"));
+
+						net.pass(file);
+					}
+				});
+
+			}
+
+			@Override
+			public void netsave(Simulator simulator, File net) {
+				// processFile();
+			}
+		};
+	}
+
+
+	protected abstract void generateNextPackage(Future<WP> future);
+
+}
Index: java/main/src/main/java/com/framsticks/gui/Browser.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 102)
@@ -6,4 +6,6 @@
 import com.framsticks.core.*;
 import com.framsticks.gui.console.Console;
+import com.framsticks.gui.console.DirectConsole;
+import com.framsticks.gui.console.ManagedConsole;
 import com.framsticks.gui.console.TrackConsole;
 import com.framsticks.gui.table.ColumnsConfig;
@@ -56,7 +58,7 @@
 	private static final Logger log = LogManager.getLogger(Browser.class);
 
-	protected final JoinableCollection<Frame> frames = new JoinableCollection<Frame>().setObservableName("frames");
-	protected final JoinableCollection<Tree> trees = new JoinableCollection<Tree>().setObservableName("trees");
-	protected final JoinableCollection<Console> consoles = new JoinableCollection<Console>().setObservableName("consoles");
+	protected final JoinableCollection<Frame> frames = new JoinableCollection<Frame>(JoinableCollection.FinishPolicy.OnAll).setObservableName("frames");
+	protected final JoinableCollection<Tree> trees = new JoinableCollection<Tree>(JoinableCollection.FinishPolicy.Never).setObservableName("trees");
+	protected final JoinableCollection<Console> consoles = new JoinableCollection<Console>(JoinableCollection.FinishPolicy.Never).setObservableName("consoles");
 
 	protected final List<PopupMenuEntryProvider> popupMenuEntryProviders = new LinkedList<>();
@@ -123,7 +125,18 @@
 					}
 				});
-			}
-		});
-		// addNodeActionToTreePopupMenu("", new NodeAction() )
+				menu.add(new AbstractAction("Open managed console") {
+					@Override
+					public void actionPerformed(ActionEvent e) {
+						consoles.add(new ManagedConsole().setTree(remoteTree));
+					}
+				});
+				menu.add(new AbstractAction("Open direct console") {
+					@Override
+					public void actionPerformed(ActionEvent e) {
+						consoles.add(new DirectConsole().setAddress(remoteTree.getAddress()));
+					}
+				});
+			}
+		});
 
 	}
Index: java/main/src/main/java/com/framsticks/gui/Frame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 102)
@@ -95,5 +95,5 @@
 
 	protected final Map<Tree, TreeAtFrame> treeAtFrames = new IdentityHashMap<>();
-	protected JoinableCollection<Tree> trees = new JoinableCollection<>();
+	protected JoinableCollection<Tree> trees = new JoinableCollection<Tree>().setObservableName("frame trees");
 
 	public Frame(Browser browser) {
Index: java/main/src/main/java/com/framsticks/gui/MainFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/MainFrame.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/gui/MainFrame.java	(revision 102)
@@ -51,5 +51,5 @@
 				@Override
 				public void actionPerformed(ActionEvent actionEvent) {
-					browser.autoResolvePath("/simulator/genepools/groups/0", null);
+					// browser.autoResolvePath("/simulator/genepools/groups/0", null);
 					// browser.autoResolvePath("/simulator/populations/groups/0", null;
 					// browser.autoResolvePath("/simulator/genepools/groups/0/genotypes", null);
Index: java/main/src/main/java/com/framsticks/gui/console/DirectConsole.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/console/DirectConsole.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/gui/console/DirectConsole.java	(revision 102)
@@ -4,8 +4,9 @@
 import java.util.List;
 
+import com.framsticks.communication.Address;
 import com.framsticks.communication.ClientSideRawConnection;
 import com.framsticks.communication.ConnectionListener;
-import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
 
@@ -19,7 +20,13 @@
 	}
 
-	@AutoAppendAnnotation
-	public DirectConsole setConnection(ClientSideRawConnection connection) {
-		this.connection = connection;
+
+	@ParamAnnotation
+	public DirectConsole setAddress(String address) {
+		return setAddress(new Address(address));
+	}
+
+	public DirectConsole setAddress(Address address) {
+		this.connection = new ClientSideRawConnection();
+		this.connection.setAddress(address);
 		return this;
 	}
Index: java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java	(revision 102)
@@ -46,4 +46,5 @@
 		return (ClientSideManagedConnection) connection;
 	}
+
 
 	protected void sendImplementation(String line) {
@@ -159,7 +160,8 @@
 
 	@AutoAppendAnnotation
-	public void setTree(RemoteTree tree) {
+	public ManagedConsole setTree(RemoteTree tree) {
 		this.tree = tree;
 		connection = tree.getConnection();
+		return this;
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java	(revision 102)
@@ -39,4 +39,5 @@
 	private final int div = 10;
 	private JComponent changing = null;
+	public final static float LINE_HEIGHT_FACTOR = 1.2f;
 
 	private Class<? extends Number> valueType;
@@ -46,6 +47,5 @@
 		text = new JTextField();
 
-		//TODO: that factor should be done as a constant
-		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, (int)(LINE_HEIGHT * 1.2)));
+		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, (int)(LINE_HEIGHT * LINE_HEIGHT_FACTOR)));
 
 		// ComponentUI ui = UIManager.getUI(slider);
Index: java/main/src/main/java/com/framsticks/gui/table/ProcedureColumn.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/ProcedureColumn.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/gui/table/ProcedureColumn.java	(revision 102)
@@ -38,5 +38,5 @@
 			return 0;
 		}
-		ProcedureControl.callProcedure(path, getParam(), new Object[] {});
+		ProcedureControl.callProcedure(path, getParam(), new Object[] {}, tableModel.getFrame());
 		return 0;
 	}
Index: java/main/src/main/java/com/framsticks/gui/table/TableModel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/TableModel.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/gui/table/TableModel.java	(revision 102)
@@ -13,4 +13,5 @@
 import org.apache.logging.log4j.LogManager;
 
+import com.framsticks.gui.Frame;
 import com.framsticks.params.Access;
 import com.framsticks.params.ListAccess;
@@ -166,3 +167,7 @@
 	}
 
+	public Frame getFrame() {
+		return listPanel.getFrame();
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/gui/tree/TreeCellRenderer.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/TreeCellRenderer.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/gui/tree/TreeCellRenderer.java	(revision 102)
@@ -89,7 +89,5 @@
 
 		}
-
-
-		return ImageProvider.SERVER;
+		return ImageProvider.FOLDER_OPEN;
 	}
 
Index: java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java	(revision 102)
@@ -30,4 +30,5 @@
 
 import static com.framsticks.core.TreeOperations.*;
+import static com.framsticks.params.AccessOperations.*;
 
 import java.net.Socket;
@@ -61,4 +62,5 @@
 		cliObject = new Cli(this);
 		rootTree = new LocalTree();
+		rootTree.setName(server.getName() + " root tree");
 		// rootTree.setDispatcher(new AtOnceDispatcher<Tree>());
 		rootTree.setDispatcher(server.getHosted().getDispatcher());
@@ -114,5 +116,5 @@
 	public static File printToFile(String path, Access access) {
 		ListSink sink = new ListSink();
-		access.save(sink);
+		save(access, sink);
 		return new File(path, new ListSource(sink.getOut()));
 	}
@@ -143,5 +145,4 @@
 				if (request instanceof SetRequest) {
 					SetRequest setRequest = (SetRequest) request;
-					//TODO Primitive Param?
 					tree.set(path, access.getFramsClass().getParamEntry(setRequest.getField(), PrimitiveParam.class), setRequest.getValue(), new FutureHandler<Integer>(responseCallback) {
 						@Override
@@ -198,8 +199,10 @@
 	protected void joinableStart() {
 		Dispatching.use(connection, this);
+		Dispatching.use(rootTree, this);
 	}
 
 	@Override
 	protected void joinableInterrupt() {
+		Dispatching.drop(rootTree, this);
 		Dispatching.drop(connection, this);
 	}
@@ -207,4 +210,5 @@
 	@Override
 	protected void joinableFinish() {
+
 	}
 
@@ -212,4 +216,5 @@
 	protected void joinableJoin() throws InterruptedException {
 		Dispatching.join(connection);
+		Dispatching.join(rootTree);
 	}
 
Index: java/main/src/main/java/com/framsticks/hosting/Server.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 102)
@@ -37,5 +37,5 @@
 	protected ServerSocket acceptSocket;
 	protected Tree hosted;
-	protected final JoinableCollection<ClientAtServer> clients = new JoinableCollection<ClientAtServer>();
+	protected final JoinableCollection<ClientAtServer> clients = new JoinableCollection<ClientAtServer>(JoinableCollection.FinishPolicy.Never);
 
 	public static class Accept {
@@ -68,16 +68,4 @@
 	}
 
-	@Override
-	protected void joinableInterrupt() {
-		Dispatching.drop(acceptThread, this);
-		Dispatching.drop(hosted, this);
-		Dispatching.drop(clients, this);
-		try {
-			acceptSocket.close();
-		} catch (IOException e) {
-			log.debug("exception caught during socket closing: ", e);
-		}
-		finishJoinable();
-	}
 
 	/**
@@ -101,17 +89,4 @@
 	public void childChangedState(Joinable joinable, JoinableState state) {
 		proceedToState(state);
-	}
-
-	@Override
-	protected void joinableStart() {
-		Dispatching.use(acceptThread, this);
-		Dispatching.use(hosted, this);
-		Dispatching.use(clients, this);
-		try {
-			acceptSocket = new ServerSocket();
-		} catch (IOException e) {
-			throw new FramsticksException().msg("failed to create server socket").cause(e);
-		}
-		tryBind(0);
 	}
 
@@ -175,4 +150,34 @@
 	}
 
+
+	@Override
+	protected void joinableStart() {
+		Dispatching.use(acceptThread, this);
+		Dispatching.use(hosted, this);
+		Dispatching.use(clients, this);
+		try {
+			acceptSocket = new ServerSocket();
+			acceptSocket.setReuseAddress(true);
+		} catch (IOException e) {
+			throw new FramsticksException().msg("failed to create server socket").cause(e);
+		}
+		tryBind(0);
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(acceptThread, this);
+		Dispatching.drop(hosted, this);
+		Dispatching.drop(clients, this);
+
+		try {
+			acceptSocket.close();
+		} catch (IOException e) {
+			log.debug("exception caught during socket closing: ", e);
+		}
+
+		finishJoinable();
+	}
+
 	@Override
 	protected void joinableFinish() {
Index: java/main/src/main/java/com/framsticks/model/Model.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/Model.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/model/Model.java	(revision 102)
@@ -37,5 +37,5 @@
 	public final List<NeuroConnection> neuroConnections = new ArrayList<NeuroConnection>();
 
-	//TODO: why those methods returns and accepts doubles?
+	/** Those methods accept doubles to keep consistency with Framsticks server.*/
 	@ParamAnnotation
 	public double getNumparts() { return (double)parts.size(); }
Index: java/main/src/main/java/com/framsticks/params/Access.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Access.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/Access.java	(revision 102)
@@ -44,6 +44,4 @@
 	void regRemove(EventParam param, EventListener<?> listener);
 
-	void save(SinkInterface sink);
-
 	/**
 	 * Removes all the properties values.
@@ -71,4 +69,3 @@
 	ParamBuilder buildParam(ParamBuilder builder);
 
-
 }
Index: java/main/src/main/java/com/framsticks/params/AccessOperations.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/AccessOperations.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/AccessOperations.java	(revision 102)
@@ -10,4 +10,5 @@
 
 import static com.framsticks.params.SetStateFlags.*;
+import static com.framsticks.util.lang.Containers.filterInstanceof;
 
 public final class AccessOperations {
@@ -74,5 +75,40 @@
 	}
 
+	public static void save(Access access, Sink sink) {
+		if (access instanceof ObjectAccess) {
+			ObjectAccess objectAccess = (ObjectAccess) access;
+			FramsClass framsClass = access.getFramsClass();
+			assert framsClass != null;
+			sink.print(framsClass.getId()).print(":").breakLine();
+			for (PrimitiveParam<?> p : filterInstanceof(framsClass.getParamEntries(), PrimitiveParam.class)) {
+				Object value = objectAccess.get(p, Object.class);
+				if ((value == null) || value.equals(p.getDef(Object.class))) {
+					continue;
+				}
+				sink.print(p.getId()).print(":");
+				p.save(sink, value);
+				sink.breakLine();
+			}
+			sink.breakLine();
+			return;
+
+		}
+		if (access instanceof ListAccess) {
+			ListAccess listAccess = (ListAccess) access;
+			for (CompositeParam p : filterInstanceof(listAccess.getParams(), CompositeParam.class)) {
+				Object child = listAccess.get(p, Object.class);
+				//this is probably an assertion
+				assert child != null;
+				save(listAccess.getElementAccess().select(child), sink);
+			}
+			return;
+		}
+		throw new FramsticksException().msg("unknown access category").arg("access", access);
+	}
+
 	public static void load(Access access, Source source) {
+		if (!(access instanceof ObjectAccess)) {
+			throw new FramsticksException().msg("access is not an object access").arg("access", access);
+		}
 		Entry entry;
 		while ((entry = readEntry(source)) != null) {
Index: java/main/src/main/java/com/framsticks/params/ListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 102)
@@ -3,5 +3,4 @@
 
 
-import static com.framsticks.util.lang.Containers.filterInstanceof;
 
 import com.framsticks.params.types.EventParam;
@@ -30,15 +29,4 @@
 
 
-	@Override
-	public void save(SinkInterface sink) {
-		for (CompositeParam p : filterInstanceof(getParams(), CompositeParam.class)) {
-			Object child = get(p, Object.class);
-			//this is probably an assertion
-			assert child != null;
-			elementAccess.select(child);
-			elementAccess.save(sink);
-		}
-	}
-
 	public Access getElementAccess() {
 		return elementAccess;
@@ -57,8 +45,7 @@
 	}
 
-	//TODO it could actually be used also
 	@Override
 	public void tryAutoAppend(Object object) {
-		throw new InvalidOperationException();
+		throw new InvalidOperationException().msg("It could actually be used also, the Access.select could be used to check whether type is correct");
 	}
 
Index: java/main/src/main/java/com/framsticks/params/ListSink.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ListSink.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/ListSink.java	(revision 102)
@@ -7,5 +7,5 @@
  * @author Piotr Sniegowski
  */
-public class ListSink implements SinkInterface {
+public class ListSink implements Sink {
 	protected final List<String> out;
 	protected StringBuilder lineBuilder = new StringBuilder();
@@ -25,5 +25,5 @@
 
 	@Override
-	public SinkInterface print(String str) {
+	public Sink print(String str) {
 		lineBuilder.append(str);
 		return this;
@@ -31,5 +31,5 @@
 
 	@Override
-	public SinkInterface print(Object obj) {
+	public Sink print(Object obj) {
 		lineBuilder.append(obj);
 		return this;
Index: java/main/src/main/java/com/framsticks/params/Param.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Param.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/Param.java	(revision 102)
@@ -35,5 +35,4 @@
 	protected final int flags;
 
-	//TODO
 	/** The variable determining whether the parameter is an extra parameter. */
 	protected final int extra;
Index: java/main/src/main/java/com/framsticks/params/ParamCandidate.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 102)
@@ -25,4 +25,5 @@
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.params.types.ProcedureParam;
+// import com.framsticks.util.FramsticksException;
 
 public class ParamCandidate {
@@ -477,5 +478,4 @@
 			Type rawType = p.getRawType();
 			Type containedType = null;
-			//TODO make implementation here
 			boolean map = false;
 			StringBuilder b = new StringBuilder();
@@ -490,4 +490,7 @@
 				containedType = p.getActualTypeArguments()[0];
 				b.append("e");
+			} else {
+				return induceParamType(builder, rawType);
+				// throw new FramsticksException().msg("unknown raw type").arg("raw type", rawType);
 			}
 			if (!(containedType instanceof Class)) {
@@ -503,5 +506,4 @@
 			dependantClasses.add(containedClass);
 			b.append(FramsClassBuilder.getName(fca, containedClass));
-			//TODO parameterize this
 			if (map) {
 				b.append(" uid");
@@ -516,5 +518,5 @@
 			Class<?> cl = (Class<?>) type;
 
-			// TODO: future support for enum
+			// this is draft implementation of future support for enum
 			// if (cl.isEnum()) {
 			//	Class<? extends Enum<?>> enumType = (Class<? extends Enum<?>>) cl;
Index: java/main/src/main/java/com/framsticks/params/PrimitiveParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/PrimitiveParam.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/PrimitiveParam.java	(revision 102)
@@ -33,5 +33,5 @@
 	}
 
-	public void save(SinkInterface sink, Object value) {
+	public void save(Sink sink, Object value) {
 		sink.print(value);
 	}
Index: java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 102)
@@ -2,5 +2,4 @@
 
 
-import static com.framsticks.util.lang.Containers.filterInstanceof;
 
 
@@ -103,19 +102,4 @@
 	}
 
-	@Override
-	public void save(SinkInterface sink) {
-		assert framsClass != null;
-		sink.print(framsClass.getId()).print(":").breakLine();
-		for (PrimitiveParam<?> p : filterInstanceof(framsClass.getParamEntries(), PrimitiveParam.class)) {
-			Object value = get(p, Object.class);
-			if ((value == null) || value.equals(p.getDef(Object.class))) {
-				continue;
-			}
-			sink.print(p.getId()).print(":");
-			p.save(sink, value);
-			sink.breakLine();
-		}
-		sink.breakLine();
-	}
 
 	protected abstract <T> void internalSet(ValueParam param, T value);
